#This Project should be included with the boot.py and the dth.py library

#This is a µPython Script to join the TTN as a LoRaWAN application
#Registered with ABP Methode. The aim is to measure the PDR with two 
#Types of Data, Short which you can get by the method Sensor_Data()
#or the Long Data which you can get by the method Fixed_Data(). all
#you have to do to set the Data Size is to put the chosen method
#as an argument to the method LoRa_S.send(). It is better to assigne it first to a variale(PayLoad_Long = Fixed_Data())
#The script transmit a number of Packets as assigned to the variable "Count_Tx_Pack"
#after the defined number is finished the script will automatically change the SF
#Which is defined in the boot.py file under the name SF_Array. only 3 SF were chosen
#they are 7,9 and 12. The sleep time can be changed as required, I used 10 seconds to 
#faster the measurement procedures but of course, this violates the TTN policy.



""" ABP Node example compatible with the FiPy Nano Gateway """
""" This Node is the W/O J Fipy """
# DevEUI: 70b3d5499a0a4ab8   ---> W/  Jumber
# DevEUI: 70b3d5499800deb4   ---> W/O Jumber
############################################################################
# Importing the Required Liberaries (done in boot.py)
# Network connection (done in boot.py)
# Variables Defination
############################################################################

def LoRa_Intilize():
    ############################################################################
    #  LoraWan Configurations
    ############################################################################
    # Initialise LoRa in LORAWAN mode.
    lora = LoRa(mode=LoRa.LORAWAN)          # Lora Constructor - Creat lora Object from the Lora Class
    #lora = LoRa(mode=LoRa.LORAWAN,adr=True,tx_retries=1)  

    # create an ABP authentication paramsz
    # Lora MAC Address ---> 70B3D5499800DEB4   For the Application Fipy2020
     dev_addr  = struct.unpack( ">l" , ubinascii.unhexlify( '260117BD' ))[ 0 ] # these settings can be found from TTN
     nwk_swkey = ubinascii.unhexlify( '9E81780F9C179F3D559942DB692CA8D8' ) # these settings can be found from TTN
     app_swkey = ubinascii.unhexlify( 'E6B0790498B89248FF46EB374CDC8B76' ) # these settings can be found from TTN

  # create an ABP authentication paramsz
    # Lora MAC Address ---> 70B3D5499800DEB4    For the Application node_woj
    #dev_addr  = struct.unpack( ">l" , ubinascii.unhexlify( '26013297' ))[ 0 ] # these settings can be found from TTN
    #nwk_swkey = ubinascii.unhexlify( '032ACFDD0E6DEF63ECA8F08CEC8DEA87' ) # these settings can be found from TTN
    #app_swkey = ubinascii.unhexlify( '0E10427E0A0E51F6760E66552E3B1FB6' ) # these settings can be found from TTN

    # set the 3 default channels to the same frequency ( EU Configurations)
    lora.add_channel( 0 , frequency=868100000 , dr_min=0 , dr_max=5 )  # dr = 0 ---> S.F. = 12 (Slower Transmission Time but Longer Range)
    lora.add_channel( 1 , frequency=868100000 , dr_min=0 , dr_max=5 )  # dr = 5 ---> S.F. = 7 (Faster but Lower Range)
    lora.add_channel( 2 , frequency=868100000 , dr_min=0 , dr_max=5 )

    for i in range( 3 , 16 ):
        lora.remove_channel(i)
    
    # join a network using ABP (Activation By Personalisation)
    lora.join(activation=LoRa.ABP, auth=(dev_addr, nwk_swkey, app_swkey), timeout=0)    # timeout=0 --> if it doesn't connect instantinusly, Continue the Code


    # wait until  the module  has joined the network
    while not lora.has_joined():
        pycom.rgbled(0xff0000)      # Led Red ----> No connected to Lora Network yet
        time.sleep(2.5)
        print('Not joined yet...')

    print('joined ')
    #pycom.rgbled(0x00ff00)          # Led Green ---> It's Connected now

def LoRa_Scocket(SF):
    # create a LoRa socket
    LoRa_S = socket.socket(socket.AF_LORA, socket.SOCK_RAW)
    LoRa_S.setsockopt(socket.SOL_LORA, socket.SO_DR, SF )
    # make the socket non-blocking      -- We can send & Receive data w/o having to hold on the rest of our code
    LoRa_S.setblocking( False )
    return LoRa_S


def Sensor_Data():
    ############################################################################
    #  DHT11 Data   - Collect Sensor Data
    ############################################################################
    pycom.heartbeat(False)
    pycom.rgbled(0x000008) # blue   
    result = DHT_11.read()
    if result.is_valid():
        pycom.rgbled(0x001000) # green
        print("Temperature: %d C" % result.temperature)
        print("Humidity: %d %%" % result.humidity)

    hum = result.humidity
    temp = result.temperature
    ################################# Payload Short########################
    Con_Data = int(str(temp)+str(hum))
    return  ustruct.pack('h',Con_Data)

def Fixed_Data():
    ################################# Payload Long########################z    
    Id = 'A1'
    pm2_5 = 56
    pm10 = 61
    temp = 22
    humidity = 48
    #GPS  = (44.47812,7.50647)              # Tuple Lat. and Long.
    data = [Id,pm2_5,pm10,temp,humidity] 
    return ujson.dumps(data).encode()    # PayLoad_Long = Fixed_Data()

LoRa_Intilize()
LoRa_S = LoRa_Scocket(SF12_DR0)
Count_Tx_Pack = 0
Count_SF = 0
Keep_transmission = 1
print("Now Count_SF = ", str(Count_SF))                        # Debug SF value now
while Keep_transmission:
    ######################################################################
    PayLoad_Long = Fixed_Data()
    LoRa_S.send(PayLoad_Long)
    pycom.heartbeat(False)
    Count_Tx_Pack = Count_Tx_Pack + 1
    print("Count_Tx_Pack = ", str(Count_Tx_Pack))              # Debug How many packet was sent
    if Count_Tx_Pack == 100:           # 100 Packet for UL 
        Count_Tx_Pack = 0
        if Count_SF < 5:
            Count_SF = Count_SF + 1
            print("Now Count_SF = ", str(Count_SF))            # Debug the changing of SF
            LoRa_S  = LoRa_Scocket(int(SF_Array[Count_SF]))
        else:
            Keep_transmission = 0
            print("Transmission Ends")                         # If packet still < 100 keep using same SF
    time.sleep(10)                                              # Should ba change according to the Fair access policy
#""" Your own code can be written below!  70B3D5499A0A4AB8   """          
    #  The Follwing Code is for the DownLink (GT -> Sensor), uncoment if need
    
